/*******************************************************************************
 * Pattern signature of the uml.validation.incompatibleSpecification pattern
 * Generated by EMF-IncQuery
 *******************************************************************************/

package signatures.uml.validation;

import java.util.Arrays;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.viatra2.emf.incquery.runtime.api.IPatternSignature;
import org.eclipse.viatra2.emf.incquery.runtime.api.impl.BasePatternSignature;

/**
 * Pattern-specific signature object of the uml.validation.incompatibleSpecification pattern.
 * Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters, 
 * usable e.g. to represent a match of the pattern in the result of a query, 
 * or to specify the bound (fixed) input parameters when issuing a query.
 */
@SuppressWarnings("unused")
public final class IncompatibleSpecificationSignature extends BasePatternSignature implements IPatternSignature {

	// constructor
	public IncompatibleSpecificationSignature(Object Behavior, Object Operation) {
		this.fBehavior = Behavior;
		this.fOperation = Operation;	
	}

	//private attributes
	private Object fBehavior;
	private Object fOperation;
	
	// getter methods
	/** Returns the value of the parameter with the given name, or null if name is invalid. */
	@Override
	public Object get(String parameterName) {
		if ("Behavior".equals(parameterName)) return fBehavior;
		if ("Operation".equals(parameterName)) return fOperation;
		return null;
	}	
	
	public Object getValueOfBehavior(){
		 return fBehavior;
	}
	public Object getValueOfOperation(){
		 return fOperation;
	}	
	
	// setter methods
	/** 
	 * Sets the parameter with the given name to the given value. 
	 * @returns true if successful, false if parameter name is invalid. May also fail and return false if the value type is incompatible. 
	 */
	@Override
	public boolean set(String parameterName, Object newValue) {
		if ("Behavior".equals(parameterName)) {
			fBehavior = newValue;
			return true;
		}
		if ("Operation".equals(parameterName)) {
			fOperation = newValue;
			return true;
		}
		return false;
	}
	
	public void setValueOfBehavior(Object Behavior){
		 this.fBehavior=Behavior;
	}
	public void setValueOfOperation(Object Operation){
		 this.fOperation=Operation;
	}

	// overridden prettyPrint(), hashCode(), equals() with Tuple-semantics
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (! (obj instanceof IPatternSignature))
			return false;
		IPatternSignature otherSig = (IPatternSignature) obj;
		if (!patternName().equals(otherSig.patternName()))
			return false;
		if (!IncompatibleSpecificationSignature.class.equals(obj.getClass()))
			return Arrays.deepEquals(toArray(), otherSig.toArray());
		IncompatibleSpecificationSignature other = (IncompatibleSpecificationSignature) obj;
		if (fBehavior == null) {if (other.fBehavior != null) return false;}
		else if (!fBehavior.equals(other.fBehavior)) return false;
		if (fOperation == null) {if (other.fOperation != null) return false;}
		else if (!fOperation.equals(other.fOperation)) return false;
		return true;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((fBehavior == null) ? 0 : fBehavior.hashCode());
		result = prime * result + ((fOperation == null) ? 0 : fOperation.hashCode());
		return result;
	}

	@Override
	public String prettyPrint() {
		StringBuilder result = new StringBuilder();
		result.append("\"Behavior\"=" + prettyPrintValue(fBehavior));
		result.append(", \"Operation\"=" + prettyPrintValue(fOperation));
		return result.toString();
	}

	// conversion and reflection
	/** Converts the signature to an array representation, with each pattern parameter at their respective position */
	@Override
	public Object[] toArray() {
		return new Object[] {fBehavior, fOperation};
	}
	
	/** Identifies the name of the pattern for which this is a signature. */
	@Override
	public String patternName() {
		return "uml.validation.incompatibleSpecification";
	}
	
	/** Returns the list of symbolic parameter names. */
	@Override
	public String[] parameterNames() {
		return parameterNames;
	}
	private static String[] parameterNames = {"Behavior", "Operation"};
	
	
}
